local _, addon = ...

local classSpells = {
	["DRUID"] = {
		dispel = addon.GetSpellInfo(88423), --Nature's Cure	
		combatRes = addon.GetSpellInfo(20484), --Rebirth
		res = addon.GetSpellInfo(50769), --Revive
	},
}

local function buildMacro(class, unit)
	local str = ""

	if(unit and classSpells[class]) then
		local dispel = classSpells[class].dispel
		local res = classSpells[class].res
		local combatRes = classSpells[class].combatRes

		local dispelMacro = "/cast [@%s,exists,help,nodead] %s;"
		local combatResMacro = "/cast [@%s,exists,help,combat,dead] %s;"
		local resMacro = "/cast [@%s,exists,help,nocombat,dead] %s;"

		if(dispel) then
			str = str..dispelMacro:format(unit, dispel)
		end

		if(combatRes) then
			str = str..combatResMacro:format(unit, combatRes)
		end

		if(res) then
			str = str..resMacro:format(unit, res)
		end

		--print(str)
	end

	return str
end

local Update = function(self)
	if(not InCombatLockdown() and not IsAddOnLoaded("Clique")) then
		self:SetAttribute("*type3", "macro")
		self:SetAttribute("macrotext3", buildMacro(addon.class, self.unit))
	end
end

local Enable = function(self)

end

addon:AddMod("Click", Update, Enable)

