local _, addon = ...

local function healPostUpdate(element, unit, overAbsorb, overHealAbsorb)
	local self = element.__owner

	if(element.overAbsorbGlow) then
		if(overAbsorb) then
			element.overAbsorbGlow:Show()
		else
			element.overAbsorbGlow:Hide()
		end
	end

	-- hack to fix bar size not updating
	if(element.myBar:GetValue() == 0) then
		element.myBar:SetValue(.01)
	end
	if(element.otherBar:GetValue() == 0) then
		element.otherBar:SetValue(.01)
	end
	if(element.absorbBar:GetValue() == 0) then
		element.absorbBar:SetValue(.01)
	end
	if(element.healAbsorbBar:GetValue() == 0) then
		element.healAbsorbBar:SetValue(.01)
	end
end

local Update = function(self)
	local myBar = self.HealPrediction.myBar
	myBar:SetStatusBarTexture(1,1,1, "BORDER")
	myBar:SetStatusBarColor(unpack(self.db.heals.myBar.color))

	myBar:ClearAllPoints()
	myBar:SetPoint("TOP", self.Health)
	myBar:SetPoint("BOTTOM", self.Health)
	myBar:SetPoint("LEFT", self.Health:GetStatusBarTexture(), "RIGHT")
	myBar:SetWidth(self:GetWidth())

	local otherBar = self.HealPrediction.otherBar
	otherBar:SetStatusBarTexture(1,1,1, "BORDER")
	otherBar:SetStatusBarColor(unpack(self.db.heals.otherBar.color))

	otherBar:ClearAllPoints()
	otherBar:SetPoint("TOP", myBar)
	otherBar:SetPoint("BOTTOM", myBar)
	otherBar:SetPoint("LEFT", myBar:GetStatusBarTexture(), "RIGHT")
	otherBar:SetWidth(self:GetWidth())

	local absorbBar = self.HealPrediction.absorbBar
	absorbBar:SetStatusBarTexture(1,1,1, "BORDER")
	absorbBar:SetStatusBarColor(unpack(self.db.heals.absorbBar.color))

	absorbBar:ClearAllPoints()
	absorbBar:SetPoint("TOP", otherBar)
	absorbBar:SetPoint("BOTTOM", otherBar)
	absorbBar:SetPoint("LEFT", otherBar:GetStatusBarTexture(), "RIGHT")
	absorbBar:SetWidth(self:GetWidth())

	local overAbsorbGlow = self.HealPrediction.overAbsorbGlow
	overAbsorbGlow:ClearAllPoints()
	overAbsorbGlow:SetTexture("Interface\\RaidFrame\\Shield-Overshield")
	overAbsorbGlow:SetBlendMode("ADD")
	overAbsorbGlow:SetPoint("BOTTOMLEFT", self.Health, "BOTTOMRIGHT", -4, 0)
	overAbsorbGlow:SetPoint("TOPLEFT", self.Health, "TOPRIGHT", -4, 0)
	overAbsorbGlow:SetWidth(10)

	local healAbsorbBar = self.HealPrediction.healAbsorbBar
	healAbsorbBar:SetStatusBarTexture(1,1,1, "BORDER")
	healAbsorbBar:SetStatusBarColor(unpack(self.db.heals.healAbsorbBar.color))	

	healAbsorbBar:ClearAllPoints()	
	healAbsorbBar:SetPoint("TOP")
	healAbsorbBar:SetPoint("BOTTOM")
	healAbsorbBar:SetPoint("LEFT", self.Health:GetStatusBarTexture(), "RIGHT", -(self:GetWidth()), 0)
	healAbsorbBar:SetWidth(self:GetWidth())

	self.HealPrediction.maxOverflow = self.db.heals.maxOverflow
end

local Enable = function(self)
	local myBar = CreateFrame("StatusBar", nil, self)
	myBar:Hide()

	local otherBar = CreateFrame("StatusBar", nil, self)
	otherBar:Hide()

	local absorbBar = CreateFrame("StatusBar", nil, self)
	absorbBar:Hide()

	local overAbsorbGlow = self.Health:CreateTexture(nil, "ARTWORK", nil, 1)
	overAbsorbGlow:Hide()

	local healAbsorbBar = CreateFrame("StatusBar", nil, self.Health)	
	healAbsorbBar:SetReverseFill(true)
	healAbsorbBar:Hide()

	local healpredict = {
		myBar = myBar,
		otherBar = otherBar,
		absorbBar = absorbBar,
		overAbsorbGlow = overAbsorbGlow,
		healAbsorbBar = healAbsorbBar,
		maxOverflow = 1.05,
		frequentUpdates = true,
	}

	healpredict.PostUpdate = healPostUpdate

	self.HealPrediction = healpredict
end

addon:AddMod("Heals", Update, Enable)

