local _, addon = ...

local function OnEnter(self)
	self.HL:Show()
	UnitFrame_OnEnter(self)
end

local function OnLeave(self)
	self.HL:Hide()
	UnitFrame_OnLeave(self)
end

local PIconOverride = function(self, event)
	local picon = self.PhaseIcon	

	local isValid = addon:validUnit(self.unit)
	local inPhase = UnitInPhase(self.unit)
	if(not inPhase and isValid) then
		picon:Show()
	else
		picon:Hide()
	end
end

local function targetUpdate(self)
	if(UnitIsUnit("target", self.unit)) then
		self.TagetBorder:Show()
	else
		self.TagetBorder:Hide()
	end
end

local Update = function(self)

end

local Enable = function(self)

	local hl = self.Overlay:CreateTexture(nil, "OVERLAY")
	hl:SetTexture("Interface\\Buttons\\WHITE8x8")
	hl:SetAllPoints(self)
	hl:SetVertexColor(1,1,1,.1)
	hl:Hide()

	self.HL = hl

	self:SetScript("OnEnter", OnEnter)
	self:SetScript("OnLeave", OnLeave)

	local ricon = self.Overlay:CreateTexture(nil, "OVERLAY")
	ricon:SetPoint("BOTTOM", self, "TOP", 0, -5)
	ricon:SetSize(14, 14)

	self.RaidIcon = ricon

	local leader = self.Overlay:CreateTexture(nil, "OVERLAY")
	leader:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, -3)
	leader:SetSize(12, 12)

	self.Leader = leader

	local assistant = self.Overlay:CreateTexture(nil, "OVERLAY")
	assistant:SetAllPoints(leader)
	assistant:SetSize(12, 12)

	self.Assistant = assistant

	local masterlooter = self.Overlay:CreateTexture(nil, "OVERLAY")
	masterlooter:SetPoint("LEFT", self, "RIGHT", 2, 0)
	masterlooter:SetSize(12, 12)

	self.MasterLooter = masterlooter

	local resurrect = self.Overlay:CreateTexture(nil, "OVERLAY")
	resurrect:SetPoint("CENTER", self, 0, 0)
	resurrect:SetSize(22, 22)

	self.ResurrectIcon = resurrect

	local readycheck = self.Overlay:CreateTexture(nil, "OVERLAY")
	readycheck:SetPoint("CENTER", self, 0, 0)
	readycheck:SetSize(14, 14)

	self.ReadyCheck = readycheck

	local picon = self.Overlay:CreateTexture(nil, "OVERLAY")
	picon:SetSize(16, 16)
	picon:SetPoint("CENTER", self)
	picon.Override = PIconOverride
	picon:Hide()

	self.PhaseIcon = picon
	self:RegisterEvent("UNIT_MAXHEALTH", PIconOverride)

	local tarBR = CreateFrame("Frame", nil, self)
	tarBR:SetFrameLevel(0)
	tarBR:SetPoint("TOPLEFT", -4, 4)
	tarBR:SetPoint("BOTTOMRIGHT", 4, -4)
	tarBR:SetBackdrop(addon.Border)
	tarBR:SetBackdropColor(1, 1, 1, 1)
	tarBR:SetBackdropBorderColor(1, 1, 1, 1)
	tarBR:Hide()

	self.TagetBorder = tarBR
	self:RegisterEvent("PLAYER_TARGET_CHANGED", targetUpdate)
	self:RegisterEvent("GROUP_ROSTER_UPDATE", targetUpdate)
end

addon:AddMod("Misc", Update, Enable)

