local ADDON_NAME, addon = ...

local CHAT_FLAG_AFK = CHAT_FLAG_AFK
local DEAD = DEAD
local OFFLINE = PLAYER_OFFLINE
local GHOST = "Ghost"

addon.tags[ADDON_NAME..":status"] = function(unit)
	local status
	
	if(UnitIsAFK(unit)) then
		status = CHAT_FLAG_AFK
	elseif(UnitIsDead(unit)) then
		status = DEAD
	elseif(UnitIsGhost(unit)) then	
		status = GHOST
	elseif(not UnitIsConnected(unit)) then
		status = OFFLINE
	elseif(false) then
		local cur, max = UnitHealth(unit), UnitHealthMax(unit)
		local hp = max - cur

		status = (hp > 0) and "-"..addon:numberize(hp)
	end

	return status
end
addon.tagevents[ADDON_NAME..":status"] = "UNIT_MAXHEALTH UNIT_HEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED"

local Update = function(self)
	local status = self.StatusText
	status:SetFont(addon.SM:Fetch("font", self.db.status.font),
	self.db.status.fontsize, self.db.status.fontflag)
	status:SetTextColor(unpack(self.db.status.color))
	
	self:Tag(status, "["..ADDON_NAME..":status]")
end

local Enable = function(self)
	local status = self.Overlay:CreateFontString(nil, "ARTWORK")
	status:SetShadowOffset(1.25, -1.25)
	status:SetPoint("LEFT", self, "LEFT")
	status:SetPoint("RIGHT", self)

	self.StatusText = status
end

addon:AddMod("Status", Update, Enable)

